/*
 * Resource.java
 *
 * Created on 25 July 2000, 13:14
 */

package com.hp.hpl.mesa.rdf.exp.model;

import java.util.Iterator;

/**
 *
 * @author  bwm
 * @version 
 */
public interface Resource extends RDFNode {
    public long    getId()                              throws RDFException;
    public String  getURI();
    public String  toString();
    public boolean equals(Object o);
    
    public Statement        getProperty(Property p)     throws RDFException;
    public StmtIterator     listProperties(Property p)  throws RDFException;
    public StmtIterator     listProperties()            throws RDFException;
    
    public Resource addProperty(Property p, boolean b)  throws RDFException;
    public Resource addProperty(Property p, byte b)     throws RDFException;
    public Resource addProperty(Property p, short s)    throws RDFException;
    public Resource addProperty(Property p, int i)      throws RDFException;
    public Resource addProperty(Property p, long l)     throws RDFException;
    public Resource addProperty(Property p, char c)     throws RDFException;
    public Resource addProperty(Property p, float f)    throws RDFException;
    public Resource addProperty(Property p, double d)   throws RDFException;
    public Resource addProperty(Property p, String s)   throws RDFException;
    public Resource addProperty(Property p, Object o)   throws RDFException;
    
    public boolean  hasProperty(Property p)             throws RDFException;
    public boolean  hasProperty(Property p, boolean b)  throws RDFException;
    public boolean  hasProperty(Property p, byte b)     throws RDFException;
    public boolean  hasProperty(Property p, short s)    throws RDFException;
    public boolean  hasProperty(Property p, int i)      throws RDFException;
    public boolean  hasProperty(Property p, long l)     throws RDFException;
    public boolean  hasProperty(Property p, char c)     throws RDFException;
    public boolean  hasProperty(Property p, float f)    throws RDFException;
    public boolean  hasProperty(Property p, double d)   throws RDFException;
    public boolean  hasProperty(Property p, String s)   throws RDFException;
    public boolean  hasProperty(Property p, Literal l)  throws RDFException;
    public boolean  hasProperty(Property p, Object o  ) throws RDFException;
    
    public Resource delete()                            throws RDFException;
    
    public Resource begin()                             throws RDFException;
    public Resource abort()                             throws RDFException;
    public Resource commit()                            throws RDFException;
}
    
